using CloudBuilder.Core.Authorization;
using CloudBuilder.Core.DatabaseAccessor.Entity;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
namespace CloudBuilder.AI.Entity
 {
    [TypeScript]
    [Table("ai_chapter")]
    public class AiChapterEntity : EntityBase<string>
    {

    public AiChapterEntity() 
    {
    }

    [Column("created_datetime")]
    public DateTime CreatedDatetime  { get; set; }
    [Column("created_by")]
    public string CreatedBy  { get; set; }
    [Column("updated_datetime")]
    public DateTime UpdatedDatetime  { get; set; }
    [Column("updated_by")]
    public string UpdatedBy  { get; set; }
    [Key]
    [Column("guid")]
    public string Guid  { get; set; }
    [Column("book_guid")]
    public string BookGuid  { get; set; }
    [Column("chapter_index")]
    public int ChapterIndex  { get; set; }
    [Column("title")]
    public string Title  { get; set; }
    [Column("content")]
    public string Content  { get; set; }
    [Column("status")]
    public string Status  { get; set; }

    public const string CREATED_DATETIME = "CreatedDatetime";
    public const string CREATED_BY = "CreatedBy";
    public const string UPDATED_DATETIME = "UpdatedDatetime";
    public const string UPDATED_BY = "UpdatedBy";
    public const string GUID = "Guid";
    public const string BOOK_GUID = "BookGuid";
    public const string CHAPTER_INDEX = "ChapterIndex";
    public const string TITLE = "Title";
    public const string CONTENT = "Content";
    public const string STATUS = "Status";

    public const string DB_NAME_AI_CHAPTER = "ai_chapter";
    public const string DB_NAME_FIELDS="created_datetime,created_by,updated_datetime,updated_by,guid,book_guid,chapter_index,title,content,status";

    public const string DB_CREATED_DATETIME = "created_datetime";
    public const string DB_CREATED_BY = "created_by";
    public const string DB_UPDATED_DATETIME = "updated_datetime";
    public const string DB_UPDATED_BY = "updated_by";
    public const string DB_GUID = "guid";
    public const string DB_BOOK_GUID = "book_guid";
    public const string DB_CHAPTER_INDEX = "chapter_index";
    public const string DB_TITLE = "title";
    public const string DB_CONTENT = "content";
    public const string DB_STATUS = "status";


    public static AiChapterEntity GetInstance()
    {
        return new AiChapterEntity();
    }

    public virtual void CopyFrom(AiChapterEntity source)
    {
        CopyFrom(source, true);
    }

    public virtual void CopyFrom(AiChapterEntity source, bool includeSystemFields)
    {
        if (source == null)
        {
            throw new NullReferenceException("Source entity is null.");
        }

        this.CreatedDatetime =  source.CreatedDatetime;
        this.CreatedBy =  source.CreatedBy;
        this.UpdatedDatetime =  source.UpdatedDatetime;
        this.UpdatedBy =  source.UpdatedBy;
        this.Guid =  source.Guid;
        this.BookGuid =  source.BookGuid;
        this.ChapterIndex =  source.ChapterIndex;
        this.Title =  source.Title;
        this.Content =  source.Content;
        this.Status =  source.Status;

        if (includeSystemFields)
        {
        this.CreatedDatetime =  source.CreatedDatetime;
        this.CreatedBy =  source.CreatedBy;
        this.UpdatedDatetime =  source.UpdatedDatetime;
        this.UpdatedBy =  source.UpdatedBy;
        }
    }

    public override string GetSelectFrom()
    {
        return $" select {DB_NAME_FIELDS} from { DB_NAME_AI_CHAPTER}  with(nolock) ";
    }
	
    public override string GetSelectCountFrom(string sqlWhere)
    {
        return $" select count(*) from { DB_NAME_AI_CHAPTER}  with(nolock) where 1=1 {sqlWhere}";
    }
	
    public override string GetSelectTopFrom(int limit, int start,string orderby,string orderbytag,  string sqlWhere)
    {
            if (string.IsNullOrEmpty(orderbytag)  || orderbytag.Trim() != "desc") orderbytag = "asc";
            if (string.IsNullOrEmpty(orderby) || !DB_NAME_FIELDS.Contains(orderby)) orderby =  DB_GUID ;  		
		string top = limit > 0 ? $"top {limit}" : "";
        return $" select {top} {DB_NAME_FIELDS} from (select {DB_NAME_FIELDS}  ,row_number() over(order by {orderby} {orderbytag}) as num from { DB_NAME_AI_CHAPTER}  with(nolock) where 1=1 {sqlWhere} ) a where num> {limit * (start - 1)}";
    }

    public AiChapterEntity Clone()
    {
        AiChapterEntity result = new AiChapterEntity();
        result.CopyFrom(this);

        return result;
    }

    }
}
